'use strict'

const Stream = require('stream')

module.exports = (event, callback) => {
  const response = {
    body: '',
    statusCode: 200,
    headers: {}
  }

  const req = new Stream.Readable()
  req._read = f => f
  req.url =
    '/' +
    event.requestContext.path
      .split('/')
      .slice(2)
      .join('/')
  req.method = event.httpMethod
  req.headers = event.headers
  req.connection = {}

  const res = new Stream()
  res.writeHead = (status, headers) => {
    response.statusCode = status
    if (headers) response.headers = Object.assign(response.headers, headers)
  }
  res.write = chunk => {
    response.body += chunk
  }
  res.setHeader = (name, value) => {
    response.headers[name] = value
  }
  res.end = text => {
    if (text) response.body += text
    response.headers = res.headers || {}
    callback(null, response)
  }
  if (event.body) {
    req.push(event.body)
    req.push(null)
  }

  return { req, res }
}
